# -*- coding: utf_8 -*-
"""
背景
一枚絵の垂れ流しループ
TODO 薄い雲をランダムに流す、海面を光らせる、など
"""

from eff import *
import resource
from resource import loadbg
from util import *

class BgMan:
    def __init__(self, parent):
        res = resource.res
        self.bg = Plane(parent)
        #self.bg.SetTexture(res.bg['bg'])
        self.bg.SetTexture(loadbg('bg'))
        self.bg.SetEffect(res.fx['bg'], 'TechUVAnim')
        self.bg.SetScale(V1 * 400)
        self.bg.SetDir(VZ, VY)
        self.bg.SetPos(v(0,0,100))
        self.bg.SetLayer(100)
        self.offset = - 1.0
    
    def update(self):
        self.offset -= 0.0005
        self.offset %= 4.0
        self.bg.SetEffectParam('uv_offset', v(0.0, self.offset, 0.0, 0.0))

