# -*- coding: utf_8 -*-
from os import listdir, path
from eff import *

def load(p):
    tmp = {}
    for i in listdir(p):
        n, e = path.splitext(i)
        tmp[n] = Sound(p + i)
    return tmp

# 効果音
class SeMan:
    def __init__(self):
        self.se = load('data/se/')
    
    def play(self,m):
        self.se[m].Stop()
        self.se[m].Play(1)

# BGM
class BgmMan:
    def __init__(self):
        self.bgm = load('data/bgm/')
    
    def play(self,m):
        for i in self.bgm.values():
            i.Stop()
        self.bgm[m].Play(0)

