# -*- coding: utf_8 -*-
"""
ステータス管理
TODO:ハイスコア１０個分
TODO:その他の値も保持

chain connect　9連鎖以上つながった場合、chain継続、最大９９
"""
import cPickle

class Status(object):
    def __init__(self):
        self.reset()

    def reset(self):
        self.score = 0
        self.hiscore = 0
        self.chain = 0
        self.maxchain = 0
        self.chaincnt = 0
        self.maxitem = 0
        self.load()
        self.Fchainconnect = False
        self.prevchain = 0
        self.combotimer = 0
        self.combo = 1
        
    def addScore(self, args): # event call
        self.score += args * (self.chain + 1) * self.combo
        if self.score > 9999999999:
            self.score = 9999999999
        if self.score > self.hiscore:
            self.hiscore = self.score

    def addItem(self, args): # event call
        self.maxitem += 1
        if self.maxitem > 9999999999:
            self.maxitem = 9999999999

    def addChain(self, args): # event call
        args += self.prevchain
        if self.chain <= args:
            self.chain = args
            self.chaincnt = 0
            if self.chain > 99:
                self.chain = 99
            if self.chain > self.maxchain:
                self.maxchain = self.chain

    def setCombo(self, args): # event call
        self.combo += 1
        self.combotimer = 180

    def load(self):
        try:
            fin = file("thhrd.dat","rb")
            data = cPickle.load(fin)
            fin.close()
            (self.hiscore,) = data
            print "load:thhrd.dat"
        except:
            print "load failed:thhrd.dat"
    
    def save(self):
        """
        TODO:saveする場所をappdata以下に
        """
        data = (self.hiscore,)
        fout = file("thhrd.dat","wb")
        cPickle.dump(data, fout, cPickle.HIGHEST_PROTOCOL)
        fout.close()
        print "save:thhrd.dat"
        self.reset()

    def update(self, event):
        self.chaincnt += 1
        if self.chaincnt == 30: # 確定まで３０Ｆ
            if self.chain > 0:
                event.append({'type':'achievement','args':{'type':'chain', 'param':self.chain}})
            if self.chain >= self.prevchain + 9:
                self.prevchain = self.chain
                self.Fchainconnect = True
            else:
                self.prevchain = 0
                self.Fchainconnect = False
            if not self.Fchainconnect:
                self.chain = 0
        if self.combo > 1:
            self.combotimer -= 1
            if self.combotimer <= 0:
                self.combo = 1

