# -*- coding: utf_8 -*-
"""
キャラクタ用ベースクラス＞まだ作ってない
"""
from eff import *


class Actor(object):
    """
    そのうち作るつもりだけど結局いらないかも知れないなあ
    """
    pass


class Event(object):
    """
    イベント
    指定時間が来たら登録したイベントを返したりする
    """
    def __init__(self, clear = ('task',)):
        """
        clear:クリアしないイベントのタグ
        """
        self.que = {}
        self.cnt = 0
        self.localframe = 0
        self.clearev = clear

    def __iter__(self):
        q = self.que
        for i in q.keys():
            if q[i][3] < self.localframe:
                q.pop(i)
            else:
                dt = self.localframe - q[i][2]
                if dt >= 0:
                    yield (q[i][0], q[i][1], dt)
        self.localframe += 1

    def add(self, type, args, st = 0, et = 0):
        """
        type
        args typeのパラメータ
        st,et 開始、終了フレーム
        """
        self.que[self.cnt] = (type, args, self.localframe + st, self.localframe + st + et)
        self.cnt += 1

    def clear(self):
        """
        もうちょっと融通がきく方がええねんけど
        """
        q = self.que
        for i in q.keys():
            if q[i][0] not in self.clearev:
                q.pop(i)




# mixin
class Space(object):
    def setSpace(self, sp):
        """
        所属する領域に自分自身を返す
        """
        if self.root.checkRange():
            return
        p = self.root.pos
        x = int((p.x + 125) / 50)
        if 0 <= x <= 4:
            y = int((p.y + 160) / 64)
            if 0 <= y <= 4:
                sp[x + y * 5].append(self)

    def getIdx(self):
        """
        所属する領域のindexを返す
        """
        p = self.root.pos
        x = int((p.x + 125) / 50)
        if 0 <= x <= 4:
            y = int((p.y + 160) / 64)
            if 0 <= y <= 4:
                return x + y * 5
        return -1
